//
//  JPAppDelegate.m
//  Octotco
//
//  Created by Johannes Plunien on 11/15/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "JPAppDelegate.h"
#import "JPRepo.h"
#import "JPWatcher.h"
#import "JPIssue.h"

@implementation JPAppDelegate

@synthesize window = _window;

#pragma mark - RestKit

- (void)initRestKit
{
    RKObjectManager* objectManager = [RKObjectManager objectManagerWithBaseURL:@"https://api.github.com"];
    objectManager.client.requestQueue.showsNetworkActivityIndicatorWhenBusy = YES;

    RKObjectMapping* repoMapping = [RKObjectMapping mappingForClass:[JPRepo class]];
    [repoMapping mapKeyPath:@"name" toAttribute:@"name"];
    [repoMapping mapKeyPath:@"description" toAttribute:@"description"];
    [repoMapping mapKeyPath:@"fork" toAttribute:@"isFork"];
    [repoMapping mapKeyPath:@"watchers" toAttribute:@"watchers"];
    [repoMapping mapKeyPath:@"open_issues" toAttribute:@"openIssues"];
    [objectManager.mappingProvider addObjectMapping:repoMapping];

    RKObjectMapping* watcherMapping = [RKObjectMapping mappingForClass:[JPWatcher class]];
    [watcherMapping mapKeyPath:@"login" toAttribute:@"login"];
    [watcherMapping mapKeyPath:@"avatar_url" toAttribute:@"avatarUrl"];
    [objectManager.mappingProvider addObjectMapping:watcherMapping];

    RKObjectMapping* issueMapping = [RKObjectMapping mappingForClass:[JPIssue class]];
    [issueMapping mapKeyPath:@"title" toAttribute:@"title"];
    [objectManager.mappingProvider addObjectMapping:issueMapping];
}

#pragma mark - Application lifecycle

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    [self initRestKit];
    return YES;
}
							
- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

@end
