//
//  JPLinkHeaderParser.m
//  Octotco
//
//  Created by Johannes Plunien on 11/17/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "JPLinkHeader.h"

@implementation JPLinkHeader

@synthesize links;

- (JPLinkHeader *)initWithString:(NSString *)string
{
    self = [super init];
    if (string != nil) {
        [self parseLinkHeaderString:string];
    }
    return self;
}

- (NSURL *)getUrl:(NSString *)key
{
    return [self.links valueForKey:key];
}

- (void)parseLinkHeaderString:(NSString *)string
{
    NSError *error = NULL;

    NSRegularExpression *regex = [NSRegularExpression
                                  regularExpressionWithPattern:@"<([^>]+)>; rel=\"([^\"]+)\""
                                  options:NSRegularExpressionCaseInsensitive
                                  error:&error];

    NSUInteger numberOfMatches = [regex
                                  numberOfMatchesInString:string
                                                  options:0
                                                    range:NSMakeRange(0, [string length])];

    NSDictionary *result = [[[NSMutableDictionary alloc] initWithCapacity:numberOfMatches] autorelease];

    [regex enumerateMatchesInString:string options:0 range:NSMakeRange(0, [string length]) usingBlock:^(NSTextCheckingResult *match, NSMatchingFlags flags, BOOL *stop) {
        NSURL *url = [NSURL URLWithString:[string substringWithRange:[match rangeAtIndex:1]]];
        NSString *rel = [string substringWithRange:[match rangeAtIndex:2]];
        [result setValue:url forKey:rel];
    }];

    self.links = result;
}

#pragma mark - Lifecycle

- (void)dealloc
{
    [super dealloc];
    self.links = nil;
}

@end
