//
//  JPRepoDetailViewController.m
//  Octotco
//
//  Created by Johannes Plunien on 11/17/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "JPRepoDetailViewController.h"
#import "JPRepoWatchersViewController.h"

@implementation JPRepoDetailViewController

@synthesize user, repo, nameLabel, descriptionLabel, forkImage, watchersLabel, openIssuesLabel;

#pragma mark - UIViewController methods

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
	if ([segue.identifier isEqualToString:@"RepoWatchers"] || [segue.identifier isEqualToString:@"RepoIssues"]) {
        JPRepoWatchersViewController *repoWatchersViewController = segue.destinationViewController;
        [repoWatchersViewController setRepo:self.repo];
        [repoWatchersViewController setUser:self.user];
	}
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.nameLabel.text = self.repo.name;
    self.descriptionLabel.text = self.repo.description;
    self.openIssuesLabel.text = self.repo.openIssues;
    self.watchersLabel.text = self.repo.watchers;
    if (self.repo.isFork) {
        self.forkImage.hidden = false;
    }
    else {
        self.forkImage.hidden = true;
    }
}

#pragma mark - Lifecycle

- (void)dealloc
{
    self.user = nil;
    self.repo = nil;
    self.nameLabel = nil;
    self.descriptionLabel = nil;
}

@end
