//
//  JPRepoIssuesViewController.m
//  Octotco
//
//  Created by Johannes Plunien on 11/18/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "JPRepoIssuesViewController.h"
#import "JPIssue.h"

@implementation JPRepoIssuesViewController

@synthesize user, repo;

#pragma mark - JPTableViewController methods

- (NSString *)getObjectClass
{
    return @"JPIssue";
}

#pragma mark - UITableViewDataSource methods

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.row < [self.rows count]) {
        JPIssue *issue = [self.rows objectAtIndex:indexPath.row];
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"IssuesCell"];

        cell.textLabel.text = issue.title;

        return cell;
    }
    else {
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"LoadingCell"];
        return cell;
    }
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    NSString *path = [[[NSString alloc] initWithFormat:@"/repos/%@/%@/issues", self.user, self.repo.name] autorelease];
    [self loadRowsAtResourcePath:path];
}

#pragma mark - Lifecycle

- (void)dealloc
{
    self.repo = nil;
    self.user = nil;
}

@end
