//
//  JPRepoListViewController.m
//  Octotco
//
//  Created by Johannes Plunien on 11/15/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "JPRepoListViewController.h"
#import "JPRepoDetailViewController.h"
#import "JPRepo.h"
#import "JPRepoListCell.h"

@implementation JPRepoListViewController

@synthesize user;

#pragma mark - JPTableViewController methods

- (NSString *)getObjectClass
{
    return @"JPRepo";
}

#pragma mark - UIViewController methods

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
	if ([segue.identifier isEqualToString:@"RepoDetail"]) {
        JPRepoDetailViewController *repoDetailViewController = segue.destinationViewController;
        NSIndexPath *indexPath = [self.tableView indexPathForSelectedRow];
        JPRepo *repo = [self.rows objectAtIndex:indexPath.row];
        [repoDetailViewController setRepo:repo];
        [repoDetailViewController setUser:self.user];
	}
}

#pragma mark - UITableViewDataSource methods

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.row < [self.rows count]) {
        JPRepo *repo = [self.rows objectAtIndex:indexPath.row];
        JPRepoListCell *cell = [tableView dequeueReusableCellWithIdentifier:@"RepoListCell"];

        cell.nameLabel.text = repo.name;
        cell.descriptionLabel.text = repo.description;

        if (repo.isFork) {
            cell.forkImage.hidden = false;
        }
        else {
            cell.forkImage.hidden = true;
        }

        return cell;
    }
    else {
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"LoadingCell"];
        return cell;
    }
}

#pragma mark - UISearchBarDelegate methods

- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar
{
    [searchBar resignFirstResponder];
    self.user = searchBar.text;
    self.rows = nil;
    NSString *path = [[[NSString alloc] initWithFormat:@"/users/%@/repos", self.user] autorelease];
    [self loadRowsAtResourcePath:path];
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    UISearchBar *searchBar = [[[UISearchBar alloc] initWithFrame:CGRectMake(-5.0, 0.0, 320.0, 44.0)] autorelease];
    searchBar.autoresizingMask = UIViewAutoresizingFlexibleWidth;
    UIView *searchBarView = [[UIView alloc] initWithFrame:CGRectMake(0.0, 0.0, 310.0, 44.0)];
    searchBarView.autoresizingMask = 0;
    searchBar.delegate = self;
    searchBar.placeholder = @"Github username...";
    [searchBarView addSubview:searchBar];
    self.navigationItem.titleView = searchBarView;
}

#pragma mark - Lifecycle

- (void)dealloc
{
    self.user = nil;
}

@end
