//
//  JPRepoWatchersViewController.m
//  Octotco
//
//  Created by Johannes Plunien on 11/17/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "JPRepoWatchersViewController.h"
#import "JPWatcher.h"
#import "JPRepoWatchersCell.h"

@implementation JPRepoWatchersViewController

@synthesize user, repo;

#pragma mark - JPTableViewController methods

- (NSString *)getObjectClass
{
    return @"JPWatcher";
}

#pragma mark - UITableViewDataSource methods

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.row < [self.rows count]) {
        JPWatcher *watcher = [self.rows objectAtIndex:indexPath.row];
        JPRepoWatchersCell *cell = [tableView dequeueReusableCellWithIdentifier:@"WatchersCell"];

        [cell.avatarImage setImageWithURL:[NSURL URLWithString:watcher.avatarUrl]
                         placeholderImage:[UIImage imageNamed:@"gravatar-140.png"]];

        cell.loginLabel.text = watcher.login;

        return cell;
    }
    else {
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"LoadingCell"];
        return cell;
    }
}

#pragma mark - RKObjectLoaderDelegate methods

- (void)objectLoader:(RKObjectLoader *)objectLoader didLoadObjects:(NSArray *)objects
{
    [super objectLoader:objectLoader didLoadObjects:objects];

    // Prefetch all avatar images
    SDWebImageManager *manager = [SDWebImageManager sharedManager];

    for (JPWatcher *row in self.rows) {
        NSURL *url = [NSURL URLWithString:row.avatarUrl];
        UIImage *cachedImage = [manager imageWithURL:url];
        if (!cachedImage) {
            [manager downloadWithURL:url delegate:self];
        }
    }
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    NSString *path = [[[NSString alloc] initWithFormat:@"/repos/%@/%@/watchers", self.user, self.repo.name] autorelease];
    [self loadRowsAtResourcePath:path];
}

#pragma mark - Lifecycle

- (void)dealloc
{
    self.repo = nil;
    self.user = nil;
}

@end
