//
//  OctotcoTests.m
//  OctotcoTests
//
//  Created by Johannes Plunien on 11/15/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "OctotcoTests.h"
#import "JPLinkHeader.h"

@implementation OctotcoTests

- (void)setUp
{
    [super setUp];
    
    // Set-up code here.
}

- (void)tearDown
{
    // Tear-down code here.
    
    [super tearDown];
}

- (void)testLinkHeaderParser
{
    NSString *headerString = @"Link: <https://api.github.com/users/rjbs/repos?page=2>; rel=\"next\", <https://api.github.com/users/rjbs/repos?page=11>; rel=\"last\"";
    JPLinkHeader *link = [[JPLinkHeader alloc] initWithString:headerString];

    NSString *expected = @"https://api.github.com/users/rjbs/repos?page=2";
    NSString *got = [NSString stringWithFormat:@"%@", [link getUrl:@"next"]];
    STAssertEqualObjects(got, expected, nil);

    expected = @"https://api.github.com/users/rjbs/repos?page=11";
    got = [NSString stringWithFormat:@"%@", [link getUrl:@"last"]];
    STAssertEqualObjects(got, expected, nil);

    STAssertNil([link getUrl:@"foo"], nil);

    headerString = @"<https://api.github.com/users/rjbs/repos?page=6>; rel=\"next\", <https://api.github.com/users/rjbs/repos?page=11>; rel=\"last\", <https://api.github.com/users/rjbs/repos?page=1>; rel=\"first\", <https://api.github.com/users/rjbs/repos?page=4>; rel=\"prev\"";
    link = [[JPLinkHeader alloc] initWithString:headerString];

    expected = @"https://api.github.com/users/rjbs/repos?page=6";
    got = [NSString stringWithFormat:@"%@", [link getUrl:@"next"]];
    STAssertEqualObjects(got, expected, nil);

    expected = @"https://api.github.com/users/rjbs/repos?page=11";
    got = [NSString stringWithFormat:@"%@", [link getUrl:@"last"]];
    STAssertEqualObjects(got, expected, nil);

    expected = @"https://api.github.com/users/rjbs/repos?page=1";
    got = [NSString stringWithFormat:@"%@", [link getUrl:@"first"]];
    STAssertEqualObjects(got, expected, nil);

    expected = @"https://api.github.com/users/rjbs/repos?page=4";
    got = [NSString stringWithFormat:@"%@", [link getUrl:@"prev"]];
    STAssertEqualObjects(got, expected, nil);
}

@end
